﻿@page "/users/profile/edit/{userId:guid?}"

@using System.ComponentModel.DataAnnotations
@using System.Threading
@using Microsoft.EntityFrameworkCore
@using Microsoft.Extensions.Localization
@using OWebApplication.Operators

@inject AuthenticationStateProvider _authenticationStateProvider
@inject IDbContextFactory<OvertestDatabaseContext> _dbContextFactory
@inject IStringLocalizer<ProfileEdit> _localizer
@inject NavigationManager _navigationManager
@inject UserAccessControlOperator _userAccessControlOperator
@inject UserManager<User> _userManager

@inject ISnackbar _snackbar

<MudContainer MaxWidth="MaxWidth.Small">
    <div class="my-3">
        @if (_userFullName is not null)
        {
            <MudText Typo="Typo.h5" Class="mb-1" Style="font-weight: bold;">@_userFullName</MudText>
            <MudButton Variant="Variant.Text" Size="Size.Small" StartIcon="@Icons.Material.Filled.ChevronLeft"
                       OnClick="@(() => _navigationManager.NavigateTo($"/users/profile/{UserId}"))">@_localizer["Профіль користувача"]</MudButton>
        }
        else
        {
            <MudSkeleton SkeletonType="SkeletonType.Rectangle" Width="100%" Height="32px" Class="mb-1" />
            <MudSkeleton SkeletonType="SkeletonType.Rectangle" Width="100px" Height="30px" />
        }
    </div>

    @* [Personal information] section *@
    <MudPaper Outlined="true" Class="pa-3 mb-3">
        <MudText Typo="Typo.h6">@_localizer["Персональна інформація"]</MudText>

        @if (_personalInformationModel is null)
        {
            @for (var i = 0; i < 3; i++)
            {
                <MudSkeleton SkeletonType="SkeletonType.Rectangle" Width="100%" Height="70px" class="my-2"/>
            }
        }
        else
        {
            <EditForm Model="@_personalInformationModel" OnValidSubmit="UpdatePersonalInformationAsync" OnInvalidSubmit="UpdatePersonalInformationFailed">
                <DataAnnotationsValidator/>

                <MudTextField Label="@_localizer["Повне ім'я"]" HelperText="@_localizer["Вкажіть ваші справжні прізвище, ім'я та по-батькові"]"
                              @bind-Value="_personalInformationModel.FullName"
                              For="@(() => _personalInformationModel.FullName)"></MudTextField>

                <MudTextField Label="@_localizer["Назва навчального закладу"]" HelperText="@_localizer["Вкажіть повну назву вашого навчального закладу"]"
                              @bind-Value="_personalInformationModel.InstitutionName"
                              For="@(() => _personalInformationModel.InstitutionName)"></MudTextField>

                <MudContainer Class="pa-0 mt-3" Style="text-align: right;">
                    <MudButton ButtonType="ButtonType.Submit" Variant="Variant.Filled"
                               Color="Color.Primary" StartIcon="@Icons.Material.Filled.Save" Class="ml-auto">@_localizer["Зберегти зміни"]</MudButton>
                </MudContainer>
            </EditForm>
        }
    </MudPaper>
    @* /[Personal information] section *@
    
    <MudContainer Class="pa-0 ma-0">
        @if (_userFullName is not null)
        {
            <MudButton Variant="Variant.Text" Color="Color.Default" StartIcon="@Icons.Material.Filled.Email"
                       OnClick="@(() => _snackbar.Add("Coming soon!", Severity.Warning))">@_localizer["Змінити email"]</MudButton>
            <MudButton Variant="Variant.Text" Color="Color.Default" StartIcon="@Icons.Material.Filled.Password"
                       OnClick="@(() => _snackbar.Add("Coming soon!", Severity.Warning))">@_localizer["Змінити пароль"]</MudButton>
        }
        else
        {
            <MudSkeleton SkeletonType="SkeletonType.Rectangle" Width="100%" Height="36px"/>
        }
    </MudContainer>
</MudContainer>

@code {
    [Parameter]
    public Guid? UserId { get; set; }
    
    private Guid? _currentUserId;

    private string _userFullName;
    private PersonalInformationModel _personalInformationModel;

    private SemaphoreSlim _semaphore;

    protected override async Task OnInitializedAsync()
    {
        var authenticationState = await _authenticationStateProvider.GetAuthenticationStateAsync();
        _currentUserId = new Guid(_userManager.GetUserId(authenticationState.User));
        
        await base.OnInitializedAsync();
    }
    
    protected override void OnParametersSet()
    {
        UserId ??= _currentUserId;

        _userFullName = null;
        _personalInformationModel = null;
        
        _semaphore = new SemaphoreSlim(1, 1);
    }

    protected override async Task OnAfterRenderAsync(bool firstRender)
    {
        if (!firstRender)
            return;
        
        await using var databaseContext = _dbContextFactory.CreateDbContext();
        
        if (!await databaseContext.Users.AsNoTracking().AnyAsync(u => u.Id == UserId))
        {
            _snackbar.Add(_localizer["Користувача із заданим ідентифікатором не знайдено!"], Severity.Error, options =>
            {
                options.RequireInteraction = true;
            });
            _navigationManager.NavigateTo("/");
            return;
        }
        
        var hasAccessPrivilleges = await _userAccessControlOperator.HasEditPrivillegesAsync(databaseContext,
            _currentUserId.GetValueOrDefault(), UserId.GetValueOrDefault());

        if (!hasAccessPrivilleges)
        {
            _snackbar.Add(_localizer["Ви не маєте доступу до виконання цієї операції!"], Severity.Error, options =>
            {
                options.RequireInteraction = true;
            });
            _navigationManager.NavigateTo("/");
            return;
        }

        _personalInformationModel = await databaseContext.Users.AsNoTracking()
            .Where(u => u.Id == UserId)
            .Select(s => new PersonalInformationModel
            {
                FullName = s.FullName,
                InstitutionName = s.InstitutionName
            }).FirstAsync();
        _userFullName = _personalInformationModel.FullName;
        
        StateHasChanged();
        
        await base.OnAfterRenderAsync(true);
    }
    
    #region Update personal information methods
    
    private async Task UpdatePersonalInformationAsync()
    {
        await _semaphore.WaitAsync();
        await using var databaseContext = _dbContextFactory.CreateDbContext();

        try
        {
            _personalInformationModel.FullName = _personalInformationModel.FullName.Trim();
            _personalInformationModel.InstitutionName = _personalInformationModel.InstitutionName.Trim();

            if (_personalInformationModel.FullName.Length < 3)
            {
                UpdatePersonalInformationFailed();
                return;
            }
            
            var userObject = await databaseContext.Users.AsNoTracking().FirstAsync(u => u.Id == UserId);
            userObject.FullName = _personalInformationModel.FullName;
            userObject.InstitutionName = _personalInformationModel.InstitutionName
                is { Length: 0 } ? null
                : _personalInformationModel.InstitutionName;

            databaseContext.Users.Update(userObject);
            await databaseContext.SaveChangesAsync();

            _snackbar.Add(_localizer["Внесені зміни успішно збережено!"], Severity.Success);
        }
        finally
        {
            _semaphore.Release();
        }
    }

    private void UpdatePersonalInformationFailed()
    {
        _snackbar.Add(_localizer["Зміни у персональній інформації не було збережено - будь ласка, перевірте правильність заповнення форми."], Severity.Error);
    }
    
    #endregion
    
    private class PersonalInformationModel
    {
        [Required, MinLength(3), MaxLength(255)]
        public string FullName { get; set; }
        
        [MinLength(0), MaxLength(255)]
        public string InstitutionName { get; set; }
    }
}